Scriptname xxxAlterationQuestScript   extends Quest

actor property playerref auto

;;;;;;;;;;;;;;;;;;;; IMPRISON + FREEDOM

Actor aImprisonedActor

Function Imprison(Actor target)

	if (aImprisonedActor)
		mAlreadyImprisoned.show()
	else
		target.disable()
		aImprisonedActor = target
		RegisterForSingleUpdateGameTime(72)
	endif

EndFunction

Function Freedom(ObjectReference ref, Float fDistance = 0.0, Float fZOffset = 0.0, ObjectReference orPortal = None)

	if !(aImprisonedActor)
		mNoImprisonedActor.show()
	else
		aImprisonedActor.MoveTo(ref)
		Utility.wait(0.3)
		aImprisonedActor.enable()
		Utility.wait(0.3)
		aImprisonedActor = None
		UnregisterForUpdate()
	endif

EndFunction


Event OnUpdate()

	if (aImprisonedActor)
		aImprisonedActor = None
		mPrisonerDead.show()
		UnregisterForUpdate()
	endif

EndEvent

Message Property mPrisonerDead Auto
Message Property mNoImprisonedActor Auto
Message Property mAlreadyImprisoned Auto

;;;;;;;;;;;;;;;;;;;;;;;; PACKAGE DWEMER

Keyword Property xxxALTAnimunculiSpiderMediKW Auto
Keyword Property xxxALTAnimunculiSpiderKW Auto
Keyword Property xxxALTAnimunculiSphereKW Auto
Keyword Property xxxALTAnimunculiBallistaKW Auto
Keyword Property xxxALTAnimunculiCenturionSteamKW Auto
Keyword Property xxxALTAnimunculiCenturionFireKW Auto
Keyword Property xxxALTAnimunculiCenturionFrostKW Auto

MiscObject Property xxxALTDwarvenBallistaContainer Auto
MiscObject Property xxxALTDwarvenCenturionSteamContainer Auto
MiscObject Property xxxALTDwarvenCenturionFireContainer Auto
MiscObject Property xxxALTDwarvenCenturionFrostContainer Auto
MiscObject Property xxxALTDwarvenSphereContainer Auto
MiscObject Property xxxALTDwarvenSpiderContainer Auto
MiscObject Property xxxALTDwarvenSpiderMediContainer Auto

Explosion Property xxxALTAnimunculiSpawnExplosion Auto

function packageDwemer(objectreference o)
	actor d = o as actor

	if !d
		return
	endif

	if d.hasKeyword(xxxALTAnimunculiSpiderMediKW)
		playerref.additem(xxxALTDwarvenSpiderMediContainer, 1)
	elseif d.hasKeyword(xxxALTAnimunculiSpiderKW)
		playerref.additem(xxxALTDwarvenSpiderContainer, 1)
	elseif d.hasKeyword(xxxALTAnimunculiSphereKW)
		playerref.additem(xxxALTDwarvenSphereContainer, 1)
	elseif d.hasKeyword(xxxALTAnimunculiBallistaKW)
		playerref.additem(xxxALTDwarvenBallistaContainer, 1)
	elseif d.hasKeyword(xxxALTAnimunculiCenturionSteamKW)
		playerref.additem(xxxALTDwarvenCenturionSteamContainer, 1)
	elseif d.hasKeyword(xxxALTAnimunculiCenturionFireKW)
		playerref.additem(xxxALTDwarvenCenturionFireContainer, 1)
	elseif d.hasKeyword(xxxALTAnimunculiCenturionFrostKW)
		playerref.additem(xxxALTDwarvenCenturionFrostContainer, 1)
	endif

	;d.placeAtme(xxxALTAnimunculiSpawnExplosion)

	d.disable()
	d.delete()


EndFunction