Scriptname xxxDialogueVampireFollowerScript extends Quest Conditional

GlobalVariable Property gVampireFollowerCount Auto
ReferenceAlias Property raVampireFollowerAlias0 Auto
ReferenceAlias Property raVampireFollowerAlias1 Auto
ReferenceAlias Property raVampireFollowerAlias2 Auto
ReferenceAlias Property raVampireFollowerAlias3 Auto
ReferenceAlias Property raVampireFollowerAlias4 Auto
ReferenceAlias Property raVampireFollowerAlias5 Auto
ReferenceAlias Property raVampireFollowerAlias6 Auto
ReferenceAlias Property raVampireFollowerAlias7 Auto
ReferenceAlias Property raVampireFollowerAlias8 Auto
ReferenceAlias Property raVampireFollowerAlias9 Auto

Faction Property fDismissedVampireFollower Auto
Faction Property fCurrentVampireHireling Auto

Message Property mFollowerDismissMessage Auto
Message Property mFollowerDismissMessageWedding Auto
Message Property mFollowerDismissMessageCompanions Auto
Message Property mFollowerDismissMessageCompanionsMale Auto
Message Property mFollowerDismissMessageCompanionsFemale Auto
Message Property mFollowerDismissMessageWait Auto

;Property to tell follower to say dismissal line
Int Property iFollowerDismiss Auto Conditional

Function SetFollower(ObjectReference FollowerRef)

	
	actor FollowerActor = FollowerRef as Actor
	FollowerActor.RemoveFromFaction(fDismissedVampireFollower)
	FollowerActor.AddToFaction(fCurrentVampireHireling)
	FollowerActor.SetPlayerTeammate()
	FollowerActor.SetAV("Morality", 0)
	if (raVampireFollowerAlias0.getRef() == None)
		raVampireFollowerAlias0.ForceRefTo(FollowerActor)
	elseif(raVampireFollowerAlias1.getRef() == None)
		raVampireFollowerAlias1.ForceRefTo(FollowerActor)
	elseif(raVampireFollowerAlias2.getRef() == None)
		raVampireFollowerAlias2.ForceRefTo(FollowerActor)
	elseif(raVampireFollowerAlias3.getRef() == None)
		raVampireFollowerAlias3.ForceRefTo(FollowerActor)
	elseif(raVampireFollowerAlias4.getRef() == None)
		raVampireFollowerAlias4.ForceRefTo(FollowerActor)
	elseif(raVampireFollowerAlias5.getRef() == None)
		raVampireFollowerAlias5.ForceRefTo(FollowerActor)
	elseif(raVampireFollowerAlias6.getRef() == None)
		raVampireFollowerAlias6.ForceRefTo(FollowerActor)
	elseif(raVampireFollowerAlias7.getRef() == None)
		raVampireFollowerAlias7.ForceRefTo(FollowerActor)
	elseif(raVampireFollowerAlias8.getRef() == None)
		raVampireFollowerAlias8.ForceRefTo(FollowerActor)
	elseif(raVampireFollowerAlias9.getRef() == None)
		raVampireFollowerAlias9.ForceRefTo(FollowerActor)
	endif
	gVampireFollowerCount.mod(1)
	
EndFunction


Function FollowerWait()

	actor FollowerActor = raVampireFollowerAlias0.GetActorRef() as Actor
	FollowerActor.SetAv("WaitingForPlayer", 1)
	;follower will wait 3 days
	raVampireFollowerAlias0.RegisterForUpdateGameTime(72)

EndFunction

Function FollowerFollow()

	actor FollowerActor = raVampireFollowerAlias0.GetActorRef() as Actor
	FollowerActor.SetAv("WaitingForPlayer", 0)
	SetObjectiveDisplayed(10, abdisplayed = false)

EndFunction


Function DismissFollower(Int iMessage = 0, Int iSayLine = 1, ObjectReference FollowerRef)

	int number
	actor DismissedFollowerActor

	If raVampireFollowerAlias0.getRef() == FollowerRef && raVampireFollowerAlias0.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias0.GetActorRef() as Actor
		number = 0			
	elseif  raVampireFollowerAlias1.getRef() == FollowerRef && raVampireFollowerAlias1.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias1.GetActorRef() as Actor
		number = 1	
	elseif  raVampireFollowerAlias2.getRef() == FollowerRef && raVampireFollowerAlias2.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias2.GetActorRef() as Actor
		number = 2	
	elseif  raVampireFollowerAlias3.getRef() == FollowerRef && raVampireFollowerAlias3.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias3.GetActorRef() as Actor
		number = 3	
	elseif  raVampireFollowerAlias4.getRef() == FollowerRef && raVampireFollowerAlias4.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias4.GetActorRef() as Actor
		number = 4	
	elseif  raVampireFollowerAlias5.getRef() == FollowerRef && raVampireFollowerAlias5.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias5.GetActorRef() as Actor
		number = 5	
	elseif  raVampireFollowerAlias6.getRef() == FollowerRef && raVampireFollowerAlias6.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias6.GetActorRef() as Actor
		number = 6	
	elseif  raVampireFollowerAlias7.getRef() == FollowerRef && raVampireFollowerAlias7.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias7.GetActorRef() as Actor
		number = 7	
	elseif  raVampireFollowerAlias8.getRef() == FollowerRef && raVampireFollowerAlias8.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias8.GetActorRef() as Actor
		number = 8	
	elseif  raVampireFollowerAlias9.getRef() == FollowerRef && raVampireFollowerAlias9.GetActorRef().IsDead() == False
		DismissedFollowerActor = raVampireFollowerAlias9.GetActorRef() as Actor
		number = 9	
	EndIf

	DismissedFollowerActor.StopCombatAlarm()
	DismissedFollowerActor.SetAV("WaitingForPlayer", 0)
	DismissedFollowerActor.SetPlayerTeammate(false)
	DismissedFollowerActor.RemoveFromFaction(fCurrentVampireHireling)
	DismissedFollowerActor.AddToFaction(fDismissedVampireFollower)	

	if number == 0
		raVampireFollowerAlias0.Clear()
	elseif number == 1
		raVampireFollowerAlias1.Clear()
	elseif number == 2
		raVampireFollowerAlias2.Clear()
	elseif number == 3
		raVampireFollowerAlias3.Clear()
	elseif number == 4
		raVampireFollowerAlias4.Clear()
	elseif number == 5
		raVampireFollowerAlias5.Clear()
	elseif number == 6
		raVampireFollowerAlias6.Clear()
	elseif number == 7
		raVampireFollowerAlias7.Clear()
	elseif number == 8
		raVampireFollowerAlias8.Clear()
	elseif number == 9
		raVampireFollowerAlias9.Clear()
	endif
	iFollowerDismiss = 0
	gVampireFollowerCount.mod(-1)

EndFunction

  
