Scriptname xxxMainPlayerScript extends ReferenceAlias  Conditional

spell Property sStaggerBlock Auto

keyword property weapTypeBow Auto
Keyword property ImmuneParalysis auto

Perk Property xxxBLOReplenish0 Auto
Perk Property xxxBLOReplenish1 Auto
Perk Property xxxHIWBacklashActive0 auto
Perk Property xxxHIWBacklashActive1 auto
Perk Property xxxHIWBacklashActive2 auto

Spell Property xxxBLOReplenishStaminaSpell0 Auto
Spell Property xxxBLOReplenishStaminaSpell1 Auto

Actor Property Player Auto

GlobalVariable property Backlash auto
GlobalVariable property TimedBlock auto
GlobalVariable property TimedBlockTime auto

xxxSkyReMainQuestScript property s Auto

Event OnInit()
	RegisterForAnimationEvent(Player, "SoundPlay.NPCHumanCombatShieldBlock")
EndEvent


Event OnPlayerLoadGame()
	if (!RegisterForAnimationEvent(Player, "SoundPlay.NPCHumanCombatShieldBlock"))
		Debug.notification("Failed to register for animation event.")
	endif
	s.updateAll()
EndEvent


Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	if asEventName == "SoundPlay.NPCHumanCombatShieldBlock"
		BlockTimer()
	endif
EndEvent

Function BlockTimer()
    TimedBlock.SetValueInt(1)     ;Timed Block switch ON. Use global variable is easier to adjust.
    GotoState("TimedBlockEnd")
EndFunction

State TimedBlockEnd
	Event OnBeginState()
		Utility.Wait(TimedBlockTime.GetValue())	;Timed Block tolerance time. Use global variable is easier to adjust.
		TimedBlock.SetValueInt(0)				;Timed Block switch OFF.
		Utility.Wait(0.5)							;Forbid continuous hits of block key.
		GotoState("")
	EndEvent
	Function BlockTimer()						;Prevent overlap processing
		TimedBlock.SetValueInt(0)
	EndFunction
EndState


Event OnRaceSwitchComplete()				; Anime event is forcibly unregistered when player returns to the human from werewolf and werebear and vampirelord.
	if !player.HasKeyword(ImmuneParalysis)
		RegisterForAnimationEvent(Player, "SoundPlay.NPCHumanCombatShieldBlock")
	endif
EndEvent


Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack,  bool abBashAttack, bool abHitBlocked)
	if (TimedBlock.GetValueInt() == 1) && aksource &&  !(akProjectile) && (abHitBlocked) && (akAggressor as actor) && !akSource.hasKeyword(weapTypeBow)

		TimedBlock.SetValueInt(0)
		sStaggerBlock.cast(akAggressor, akAggressor)

		if (player.hasperk(xxxBLOReplenish1))
			xxxBLOReplenishStaminaspell1.cast(player,player)
		elseif (player.hasperk(xxxBLOReplenish0))
			xxxBLOReplenishStaminaspell0.cast(player,player)
		endif
		if (player.hasPerk(xxxHIWBacklashActive0)) || (player.hasPerk(xxxHIWBacklashActive1)) || (player.hasPerk(xxxHIWBacklashActive2))
			Backlash.SetValueInt(1)
			RegisterForSingleUpdate(3.0)
		endif
	endif
EndEvent

Event OnUpdate()
	Backlash.SetValueInt(0)
EndEvent

