Scriptname xxxNecromancyScript  extends Quest

import Utility

GlobalVariable Property xxxCONBoneMasterChanceBoneBack Auto 

Float fHarvestSkillGain = 3.0

actor property playerref auto

Explosion property xxxCONHarvestExplosion Auto

;;;;;;;;;;;;;;;;;; HARVEST

Function Harvest(ObjectReference corpse)

	race corpseRace = (corpse as actor).getRace()

	int iChanceBone = (gChanceBone.getValue()) as int
	int iChanceFlesh = (gChanceFlesh.getValue()) as int
	int iChanceHeart = (gChanceHeart.getValue()) as int

	if (Game.getPlayer().hasPerk(pHarvest2))
		iChanceBone += 20
		iChanceFlesh += 20
		iChanceHeart += 10
	elseif (Game.getPlayer().hasperk(pHarvest1))
		iChanceBone += 10
		iChanceFlesh += 10
		iChanceHeart += 5
	endif
	
	if (Utility.RandomInt() < iChanceBone)
		corpse.addItem(iBoneArm)
		game.advanceskill("conjuration", fHarvestSkillGain)
	endif
	if (Utility.RandomInt() < iChanceBone)
		game.advanceskill("conjuration", fHarvestSkillGain)
		corpse.addItem(iBoneArm)
	endif
	if (Utility.RandomInt() < iChanceBone)
		game.advanceskill("conjuration", fHarvestSkillGain)
		corpse.addItem(iBoneHand)
	endif
	if (Utility.RandomInt() < iChanceBone)
		game.advanceskill("conjuration", fHarvestSkillGain)
		corpse.addItem(iBoneHand)
	endif
	if (Utility.RandomInt() < iChanceBone)
		game.advanceskill("conjuration", fHarvestSkillGain)
		corpse.addItem(iBoneLeg)
	endif
	if (Utility.RandomInt() < iChanceBone)
		game.advanceskill("conjuration", fHarvestSkillGain)
		corpse.addItem(iBoneLeg)
	endif
	if (Utility.RandomInt() < iChanceBone)
		game.advanceskill("conjuration", fHarvestSkillGain)
		corpse.addItem(iBoneFoot)
	endif
	if (Utility.RandomInt() < iChanceBone)
		game.advanceskill("conjuration", fHarvestSkillGain)
		corpse.addItem(iBoneFoot)
	endif
	if (Utility.RandomInt() < iChanceBone)
		game.advanceskill("conjuration", fHarvestSkillGain)
		corpse.addItem(iBoneRibcage)
	endif
	if (Utility.RandomInt() < iChanceBone)
		game.advanceskill("conjuration", fHarvestSkillGain)
		corpse.addItem(iBoneSkull)
	endif

	if (corpseRace == rImperial) || (corpseRace == rBreton) || (corpseRace == rRedguard) || (corpseRace == rNord)
		if (Utility.RandomInt() < iChanceFlesh)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iFleshHuman)
		endif
		if (Game.getPlayer().hasPerk(pHarvest1)) && (Utility.RandomInt() < iChanceFlesh)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iFleshHuman)
		endif
		if (Game.getPlayer().hasPerk(pHarvest2)) && (Utility.RandomInt() < iChanceFlesh)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iFleshHuman)
		endif
		if (Utility.RandomInt() < iChanceHeart)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iHeartHuman)
		endif
	elseif (corpseRace == rHighElf) || (corpseRace == rWoodElf) || (corpseRace == rDarkElf) || (corpseRace == rOrc) || (corpseRace == FalmerRace)
		if (Utility.RandomInt() < iChanceFlesh)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iFleshElven)
		endif
		if (Game.getPlayer().hasPerk(pHarvest1)) && (Utility.RandomInt() < iChanceFlesh)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iFleshElven)
		endif
		if (Game.getPlayer().hasPerk(pHarvest2)) && (Utility.RandomInt() < iChanceFlesh)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iFleshElven)
		endif
		if (Utility.RandomInt() < iChanceHeart)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iHeartElven)
		endif
	elseif (corpseRace == rKhajiit) || (corpseRace == rArgonian)
		if (Utility.RandomInt() < iChanceFlesh)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iFleshBeast)
		endif
		if (Game.getPlayer().hasPerk(pHarvest1)) && (Utility.RandomInt() < iChanceFlesh)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iFleshBeast)
		endif
		if (Game.getPlayer().hasPerk(pHarvest2)) && (Utility.RandomInt() < iChanceFlesh)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iFleshBeast)
		endif
		if (Utility.RandomInt() < iChanceHeart)
			game.advanceskill("conjuration", fHarvestSkillGain)
			corpse.addItem(iHeartBeast)
		endif
	endif

	(corpse as actor).openInventory(true)

	Utility.wait(0.5)
	corpse.placeatme(xxxCONHarvestExplosion)
	corpse.disable()
	corpse.delete()
EndFunction

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; DECONSTRUCT SKELETON

Function deconstructSkeleton(ObjectReference corpse)

	(corpse as actor).addToFaction(fDeconstructed)
	(corpse as actor).kill()

	game.getPlayer().additem(soulgempetty, 1)

	int iChanceBone = (gChanceBone.getValue()) as int
	
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneArm)
	endif
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneArm)
	endif
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneHand)
	endif
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneHand)
	endif
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneLeg)
	endif
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneLeg)
	endif
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneFoot)
	endif
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneFoot)
	endif
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneRibcage)
	endif
	if (Utility.RandomInt() < iChanceBone)
		Game.getPlayer().addItem(iBoneSkull)
	endif
EndFunction

;;;;;;;;;;;;;;;;;;;;;;;;; REUSE SKELETON PARTS


function addRandomBoneOnDeath(objectReference deadSkeleton)

	if (deadSkeleton as actor).isInFaction(fDeconstructed)
		return
	endif

	int iChanceBoneBack = (xxxCONBoneMasterChanceBoneBack.getValue()) as int
	if (game.GetPlayer().hasPerk(xxxCONBoneMastery3))
		iCHanceBoneBack += 20
	elseif (game.GetPlayer().hasPerk(xxxCONBoneMastery1))
		iCHanceBoneBack += 10
	endif

	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneArm)
	endif
	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneArm)
	endif
	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneHand)
	endif
	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneHand)
	endif
	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneLeg)
	endif
	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneLeg)
	endif
	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneFoot)
	endif
	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneFoot)
	endif
	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneRibcage)
	endif
	if (Utility.RandomInt() < iChanceBoneBack )
		deadSkeleton.addItem(iBoneSkull)
	endif

	(deadSkeleton as actor).addToFaction(fDeconstructed)

EndFunction

;;;;;;;;;;;;;;;;;;;;;;;;;; RECURRING NIGHTMARE


Form duplicateZombie = None

function storeZombie(actor newZombie)
	duplicateZombie = newZombie.GetBaseObject()
	newZombie.placeAtMe(xxxCONRecurringNightmareStoreExplosion)
	newZombie.disable()
	newZombie.delete()
EndFunction

function cloneZombie(actor carcass)
	if !duplicateZombie
		Debug.notification("You need to store a carcass first.")
		return
	endif

	carcass.placeAtMe(xxxCONRecurringNightmareCloneExplosion)
	Actor newZombie = carcass.placeAtMe(duplicateZombie) as Actor
		if !newZombie
			Debug.notification("None new Zombie")
		endif
	newZombie.damageAV("health", 10000)
	newZombie.kill()
	;Utility.wait(0.2)
	carcass.disable()
	carcass.delete()

EndFunction

;;;;;;;;;;;;;;;;;;;;;;;;;; PROPERTIES


Race Property rImperial Auto
Race Property rBreton Auto
Race Property rRedguard Auto
Race Property rNord Auto
Race Property rWoodElf Auto
Race Property FalmerRace Auto
Race Property rHighElf Auto
Race Property rDarkElf Auto
Race Property rOrc Auto
Race Property rArgonian Auto
Race Property rKhajiit Auto

GlobalVariable Property gChanceBone Auto
GlobalVariable Property gChanceFlesh Auto
GlobalVariable Property gChanceHeart Auto

Perk Property pHarvest1 Auto
Perk Property pHarvest2 Auto

Perk Property xxxCONBoneMastery1 Auto
Perk Property xxxCONBoneMastery3 Auto

MiscObject Property iBoneArm Auto
MiscObject Property iBoneLeg Auto
MiscObject Property iBoneFoot Auto
MiscObject Property iBoneHand Auto
MiscObject Property iBoneSkull Auto
MiscObject Property iBoneRibcage Auto

Ingredient Property iHeartHuman Auto
Ingredient Property iHeartBeast Auto
Ingredient Property iHeartElven Auto
Ingredient Property iFleshHuman Auto
Ingredient Property iFleshElven Auto
Ingredient Property iFleshBeast Auto

Faction Property fHarvested Auto
Faction Property fDeconstructed Auto

Soulgem property soulgempetty auto

Explosion Property xxxCONRecurringNightmareStoreExplosion Auto
Explosion Property xxxCONRecurringNightmareCloneExplosion Auto