Scriptname xxxSNEFireExtinguisherScript extends ObjectReference  


int extinguishMethod = 0		;0 = disable, 1 = move under ground, 2 = only extinguish light
int hazardRemovalMethod = 0	;0 = disable, 1 = move under ground
int lightRemovalMethod = -1		;0 = disable, 1 = move under ground
int type = 0
ObjectReference originalFire
ObjectReference originalLight
ObjectReference originalHazard

ObjectReference opposite

Form Property xxxSNEFireLighter auto
FormList Property SneakToolsCandlesOFFFormList auto
FormList Property SneakToolsFiresOFFFormList auto
FormList Property SneakToolsTorchesOFFFormList auto
FormList Property SneakToolsFireLightsFormList auto

Sound Property FXFireOut auto

float originalZ=0.0
float zOffset = 0.0

Function extinguishFire(int fireType, ObjectReference originalFireRef, int formListIndex)
	originalFire = originalFireRef
	type = fireType

	xxxSNEFireLighterScript previous = (Game.FindClosestReferenceOfTypeFromRef(xxxSNEFireLighter, originalFire, 50) As xxxSNEFireLighterScript)
	If(previous != None)
		If(previous.getNewFire() == originalFire)
			previous.resetFire(false)
			Disable()
			Delete()
			return
		EndIf
	EndIf
	
	Form oppositeForm = getOpposite(formListIndex)

	originalLight = Game.FindClosestReferenceOfAnyTypeInListFromRef(SneakToolsFireLightsFormList, originalFire, 400)

	Form FireLgPlacedHazard = Game.GetForm(0x00057A8C)
	originalHazard = Game.FindClosestReferenceOfTypeFromRef(FireLgPlacedHazard, originalFire, 50)

	float scale = originalFire.GetScale()

	opposite = originalFire.placeAtMe(oppositeForm, 1, false, false)
	opposite.setScale(scale)
	opposite.moveTo(opposite, afZOffset = zOffset)
	opposite.Enable()

	originalFire.Disable()
	If(!originalFire.IsDisabled())
		originalZ = originalFire.GetPositionZ()
		originalFire.SetPosition(originalFire.GetPositionX(), originalFire.GetPositionY(), originalZ - 10000)
		If(originalFire.GetPositionZ() < originalZ)
			extinguishMethod = 1
		Else
			extinguishMethod = 2
			opposite.Disable()
			opposite.Delete()
		EndIf
	Else
		extinguishMethod=0
	EndIf

	If(extinguishMethod != 2)
		FXFireOut.Play(opposite)
	EndIf
	
	If(originalHazard != None)
		originalHazard.Disable()
		If(!originalHazard.IsDisabled())
			originalHazard.SetPosition(originalHazard.GetPositionX(), originalHazard.GetPositionY(), originalHazard.GetPositionZ() - 10000)
			hazardRemovalMethod = 1
		Else
			hazardRemovalMethod = 0
		EndIf
	EndIf

	If(originalLight != None)
		originalLight.Disable()
		If(!originalLight.IsDisabled())
			originalLight.SetPosition(originalLight.GetPositionX(), originalLight.GetPositionY(), originalLight.GetPositionZ() - 10000)
			lightRemovalMethod=1
		Else
			lightRemovalMethod=0
		EndIf
	EndIf
	RegisterForSingleUpdateGameTime(24)
EndFunction

Function resetFire(bool careful = true)
	If(careful && opposite.IsNearPlayer())
		RegisterForSingleUpdateGameTime(24)
		return
	else
		UnregisterForUpdateGameTime()
		If(extinguishMethod == 0)
			originalFire.Enable()
			opposite.Disable()
			opposite.Delete()
		ElseIf(extinguishMethod == 1)
			originalFire.SetPosition(originalFire.GetPositionX(), originalFire.GetPositionY(), originalZ)
			opposite.Disable()
			opposite.Delete()
		EndIf
		
		If(originalHazard != None)
			If(hazardRemovalMethod == 0)
				originalHazard.Enable()
			Else
				originalHazard.SetPosition(originalHazard.GetPositionX(), originalHazard.GetPositionY(), originalHazard.GetPositionZ() + 10000)
			EndIf
		EndIf

		If(lightRemovalMethod == 0)
			originalLight.Enable()
		Else
			originalLight.SetPosition(originalLight.GetPositionX(), originalLight.GetPositionY(), originalLight.GetPositionZ() + 10000)
		EndIf

		Disable()
		Delete()
	EndIf
EndFunction

ObjectReference Function getNewFire()
	return opposite
EndFunction

Form Function getOpposite(int index)
If(type == 2)
	If(index > 15)
		index-=1
	EndIf
	If(index > 17)
		index-=1
	EndIf
	
	return SneakToolsCandlesOFFFormList.GetAt(index)
ElseIf(type == 4)
	If(index==11)
		index=3
	EndIf
	If(index>11)
		index-=1
	EndIf

	If(index == 16)
		zOffset = 9.9414
	endIf

	If(index > 16)
		index = 16
	EndIf

	return SneakToolsFiresOFFFormList.GetAt(index)
ElseIf(type == 6)
	If(index==2)
		index=1
	EndIf

	return SneakToolsTorchesOFFFormList.GetAt(index)
Else
	return None
EndIf
EndFunction

Event OnUpdateGameTime()
	resetFire()
EndEvent

