Scriptname xxxSNEFireLighterScript extends ObjectReference  


int lightMethod = 0				;0 = disable, 1 = move under ground
int type = 0
ObjectReference originalFire = None

ObjectReference newLight = None
ObjectReference opposite = None

Form Property xxxSNEFireExtinguisher auto
FormList Property SneakToolsCandlesONFormList auto
FormList Property SneakToolsFiresONFormList auto
FormList Property SneakToolsTorchesONFormList auto

Light Property DefaultCandleLight01NS auto
Light Property LightCampFire01 auto
Light Property DefaultTorch01NS auto

Sound Property FXFireOut auto

float zOffset

Function lightFire(int fireType, ObjectReference originalFireRef, int formListIndex)
	originalFire = originalFireRef
	type = fireType

	xxxSNEFireExtinguisherScript previous = (Game.FindClosestReferenceOfTypeFromRef(xxxSNEFireExtinguisher, originalFire, 50) As xxxSNEFireExtinguisherScript)
	If(previous != None)
		If(previous.getNewFire() == originalFire)
			previous.resetFire(false)
			Disable()
			Delete()
			return
		EndIf
	EndIf

	Form oppositeForm = getOpposite(formListIndex)

	float scale = originalFire.GetScale()

	opposite = originalFire.placeAtMe(oppositeForm, 1, false, false)
	opposite.setScale(scale)
	opposite.moveTo(opposite, afZOffset = zOffset)
	opposite.Enable()

	newLight = opposite.placeAtMe(getAppropriateLight())

	Utility.Wait(0.1)

	originalFire.Disable()
	If(!originalFire.IsDisabled())
		float originalZ = originalFire.GetPositionZ()
		originalFire.SetPosition(originalFire.GetPositionX(), originalFire.GetPositionY(), originalZ - 10000)
		If(originalFire.GetPositionZ() < originalZ)
			lightMethod = 1
		Else
			newLight.Disable()
			newLight.Delete()
			newLight = None
		EndIf
	Else
		lightMethod =0
	EndIf
	RegisterForSingleUpdateGameTime(24)
EndFunction

Function resetFire(bool careful = true)
	If(careful && opposite.IsNearPlayer())
		RegisterForSingleUpdateGameTime(24)
		return
	else
		UnregisterForUpdateGameTime()
		If(lightMethod == 0)
			originalFire.Enable()
			opposite.Disable()
			opposite.Delete()
		ElseIf(lightMethod == 1)
			originalFire.SetPosition(originalFire.GetPositionX(), originalFire.GetPositionY(), originalFire.GetPositionZ() + 10000)
			opposite.Disable()
			opposite.Delete()
		EndIf
		If(!careful)
			FXFireOut.Play(opposite)
		EndIf
		
		newLight.Disable()
		newLight.Delete()

		Disable()
		Delete()
	EndIf
EndFunction

Form Function getOpposite(int index)
If(type == 1)	
	return SneakToolsCandlesONFormList.GetAt(index)
ElseIf(type == 3)
	If(index>10)
		index+=1
	endIf

	if(index == 16)
		zOffset = -9.9414
	endIf

	if(index>=17)
		index=19
	endIf

	return SneakToolsFiresONFormList.GetAt(index)
ElseIf(type == 5)
	return SneakToolsTorchesONFormList.GetAt(index)
Else
	return None
EndIf
EndFunction

Form Function getAppropriateLight()
	If(type == 1)
		return DefaultCandleLight01NS 
	ElseIf(type == 3)
		return LightCampFire01 
	ElseIf(type == 5)
		return DefaultTorch01NS 
	Else
		return None
	EndIf
EndFunction

ObjectReference Function getNewFire()
	return opposite
EndFunction

Event OnUpdateGameTime()
	resetFire()
EndEvent

