Scriptname xxxSNELightSourceAlias extends ReferenceAlias  


Keyword Property MagicDamageFire auto
Keyword Property MagicDamageFrost auto
Form Property xxxSNEFireExtinguisher auto
Form Property xxxSNEFireLighter auto
FormList Property SneakToolsCandlesOFFFormList auto
FormList Property SneakToolsCandlesONFormList auto
FormList Property SneakToolsFiresOFFFormList auto
FormList Property SneakToolsFiresONFormList auto
FormList Property SneakToolsTorchesOFFFormList auto
FormList Property SneakToolsTorchesONFormList auto
FormList Property trapGasWeapon auto
Light Property Torch01 auto

ObjectReference selfRef
Form selfForm

bool processing = false

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
If(processing)
	return
EndIf

processing=true
int hitType=0	;0 = uninteresting, 1 = fire, 2 = frost/ice

;TYPES:
;0 = UNDEFINED
;1 = candle OFF
;2 = candle ON
;3 = fire OFF
;4 = fire ON
;5 = torch OFF
;6 = torch ON
int type=0

int formListIndex=0

If(akSource As Spell)
	Spell sourceSpell = akSource As Spell
	int numEffects = sourceSpell.GetNumEffects()
	int index=0

	while(index < numEffects)
		MagicEffect nthMagicEffect = sourceSpell.GetNthEffectMagicEffect(index)
		If(nthMagicEffect.HasKeyword(MagicDamageFire))
			hitType=1
			index=numEffects
		ElseIf(nthMagicEffect.HasKeyword(MagicDamageFrost))
			hitType=2
			index=numEffects
		Else
			index+=1
		EndIf
	endWhile

	If(hitType==0)
		processing=false
		return
	EndIf
ElseIf(trapGasWeapon.hasForm(akSource) || akSource == Torch01)
	hitType=1
Else
	processing=false
	return
EndIf

selfRef = GetReference()
selfForm = selfRef.GetBaseObject()

If(SneakToolsCandlesOFFFormList.HasForm(selfForm))
	type=1
	formListIndex=getFormListIndex(SneakToolsCandlesOFFFormList, selfForm)
ElseIf(SneakToolsCandlesONFormList.HasForm(selfForm))
	type=2
	formListIndex=getFormListIndex(SneakToolsCandlesONFormList, selfForm)
ElseIf(SneakToolsFiresOFFFormList.HasForm(selfForm))
	type=3
	formListIndex=getFormListIndex(SneakToolsFiresOFFFormList, selfForm)
ElseIf(SneakToolsFiresONFormList.HasForm(selfForm))
	type=4
	formListIndex=getFormListIndex(SneakToolsFiresONFormList, selfForm)
ElseIf(SneakToolsTorchesOFFFormList.HasForm(selfForm))
	type=5
	formListIndex=getFormListIndex(SneakToolsTorchesOFFFormList, selfForm)
ElseIf(SneakToolsTorchesONFormList.HasForm(selfForm))
	type=6
	formListIndex=getFormListIndex(SneakToolsTorchesONFormList, selfForm)
Else
	processing=false
	return
EndIf

If(type==1 || type==3 || type==5)
	If(hitType==1)
		lightFire(type, formListIndex)
	Else
		processing=false
		return
	EndIf
Else
	If(hitType==2)
		extinguishFire(type, formListIndex)
	Else
		processing=false
		return
	EndIf
EndIf
processing = false
EndEvent

Function lightFire(int type, int formListIndex)
	xxxSNEFireLighterScript lighter = (selfRef.placeAtMe(xxxSNEFireLighter) As xxxSNEFireLighterScript)
	lighter.lightFire(type, selfRef, formListIndex)
EndFunction

Function extinguishFire(int type, int formListIndex)
	xxxSNEFireExtinguisherScript extinguisher = (selfRef.placeAtMe(xxxSNEFireExtinguisher) As xxxSNEFireExtinguisherScript)
	extinguisher.extinguishFire(type, selfRef, formListIndex)
EndFunction

int Function getFormListIndex(FormList list, Form object)
	int index=0
	int size = list.GetSize()
	while(index < size)
		If(list.GetAt(index) == object)
			return index
		Else
			index+=1
		EndIf
	EndWhile
EndFunction