Scriptname xxxSNERope2Script extends ObjectReference  


Actor Property playerRef auto
Spell Property SneakToolsPlayerClimbingSpell auto
ObjectReference Property climbingCollisionBox auto
Perk Property SneakToolsPlayerClimbingPerk auto
float maxZ
float minZ
float jumpHeight

Event OnLoad()
	self.setMotionType(Motion_Keyframed)
EndEvent

Function setMaxZ(float maxZZ)
	maxZ=maxZZ
EndFunction

Function setMinZ(float minZZ)
	minZ = minZZ
EndFunction

Event OnActivate(ObjectReference akActionRef)
	If(akActionRef != playerRef)
		return
	EndIf

	If(!playerRef.HasSpell(SneakToolsPlayerClimbingSpell))
		playerRef.AddSpell(SneakToolsPlayerClimbingSpell, false)
		playerRef.AddPerk(SneakToolsPlayerClimbingPerk)
		Game.ForceFirstPerson()
		Game.DisablePlayerControls(false, true, true, false, true, false, false, false, 0)
		playerRef.translateTo(playerRef.GetPositionX(), playerRef.GetPositionY(), playerRef.GetPositionZ() + 10, playerRef.GetAngleX(), playerRef.GetAngleY(), playerRef.GetAngleZ(), 100)
		climbingCollisionBox.moveTo(playerRef, 0, 0, 0, false)
		climbingCollisionBox.Enable()
		jumpHeight = Game.GetGameSettingFloat("fJumpHeightMin")
		Game.SetGameSettingFloat("fJumpHeightMin", jumpHeight*3)
		RegisterForSingleUpdate(0.1)
	Else
		float angleMult = -Math.sin(playerRef.GetAngleX())
		float zDestination = 80*angleMult
		float PCZ = playerRef.GetPositionZ()
		If(zDestination + PCZ > z - playerRef.GetHeight() - 20)
			zDestination = z - playerRef.GetHeight() - PCZ - 20
		ElseIf(zDestination + PCZ  < minZ - 10)
			zDestination = minZ - PCZ - 10
		EndIf
		climbingCollisionBox.moveTo(playerRef, 0, 0, zDestination - 10, false)
		climbingCollisionBox.Disable()
		playerRef.translateTo(playerRef.GetPositionX(), playerRef.GetPositionY(), PCZ + zDestination, playerRef.GetAngleX(), playerRef.GetAngleY(), playerRef.GetAngleZ(), 80)
		climbingCollisionBox.Enable()
	EndIf
EndEvent

Event OnUpdate()
	If(playerRef.GetAnimationVariableFloat("Speed") != 0 || (playerRef.GetAnimationVariableBool("bInJumpState") && playerRef.GetAnimationVariableFloat("VelocityZ") > 0))
		playerRef.RemoveSpell(SneakToolsPlayerClimbingSpell)
		Game.EnablePlayerControls()
		climbingCollisionBox.Disable()
		playerRef.translateTo(playerRef.GetPositionX(), playerRef.GetPositionY(), playerRef.GetPositionZ(), playerRef.GetAngleX(), playerRef.GetAngleY(), playerRef.GetAngleZ(), 100)
		playerRef.removePerk(SneakToolsPlayerClimbingPerk)
		Game.SetGameSettingFloat("fJumpHeightMin", jumpHeight)
		return
	EndIf
	RegisterForSingleUpdate(0.1)
EndEvent

