Scriptname xxxSNERopeScript extends ObjectReference  


GlobalVariable property SneakToolsFloorZ auto
Perk Property SneakToolsPlayerClimbingPerk auto
Spell Property SneakToolsPlayerClimbingSpell auto
ObjectReference Property climbingCollisionBox auto
Activator Property SneakToolsRope auto
Actor Property playerRef auto
int maxRopes = 6
int index = 1
float minZ = 0.0
float jumpHeight

ObjectReference[] ropes

Event OnLoad()
	float zPos = z
	float PCPos = SneakToolsFloorZ.GetValue() + 80
	SneakToolsFloorZ.SetValue(2000000000)

	RegisterForSingleUpdateGameTime(48)
	self.setMotionType(Motion_Keyframed)
	ropes = new ObjectReference[6]
	ropes[0] = self
	while(index < maxRopes && zPos > PCPos + 80)
		xxxSNERope2Script newRope = (self.PlaceAtMe(SneakToolsRope, 1, false, true) As xxxSNERope2Script)
		newRope.setMaxZ(self.GetPositionZ())
		zPos -= 80
		newRope.SetPosition(x, y, zPos)
		ropes[index]=newRope
		index+=1
		newRope.Enable()
		newRope.setMotionType(Motion_Keyframed)
	endWhile

	if(PCPos < zPos)
		minZ=PCPos
	else
		minZ=zPos
	endIf
	index=1
	while(index<maxRopes)
		If(ropes[index] != None)
			(ropes[index] As xxxSNERope2Script).setMinZ(minZ)
		EndIf
		index+=1
	endWhile
EndEvent

Event OnActivate(ObjectReference akActionRef)
	If(akActionRef != playerRef)
		return
	EndIf

	If(!playerRef.HasSpell(SneakToolsPlayerClimbingSpell))
		playerRef.AddSpell(SneakToolsPlayerClimbingSpell, false)
		playerRef.AddPerk(SneakToolsPlayerClimbingPerk)
		Game.ForceFirstPerson()
		Game.DisablePlayerControls(false, true, true, false, true, false, false, false, 0)
		playerRef.translateTo(playerRef.GetPositionX(), playerRef.GetPositionY(), playerRef.GetPositionZ() + 10, playerRef.GetAngleX(), playerRef.GetAngleY(), playerRef.GetAngleZ(), 100)
		climbingCollisionBox.moveTo(playerRef, 0, 0, 0, false)
		climbingCollisionBox.Enable()
		jumpHeight = Game.GetGameSettingFloat("fJumpHeightMin")
		Game.SetGameSettingFloat("fJumpHeightMin", jumpHeight*3)
		RegisterForSingleUpdate(0.1)
	Else
		float angleMult = -Math.sin(playerRef.GetAngleX())
		float zDestination = 80*angleMult
		float PCZ = playerRef.GetPositionZ()
		If(zDestination + PCZ > z - playerRef.GetHeight() - 20)
			zDestination = z - playerRef.GetHeight() - PCZ - 20
		ElseIf(zDestination + PCZ  < minZ - 10)
			zDestination = minZ - PCZ - 10
		EndIf
		climbingCollisionBox.moveTo(playerRef, 0, 0, zDestination - 10, false)
		climbingCollisionBox.Disable()
		playerRef.translateTo(playerRef.GetPositionX(), playerRef.GetPositionY(), PCZ + zDestination, playerRef.GetAngleX(), playerRef.GetAngleY(), playerRef.GetAngleZ(), 80)
		climbingCollisionBox.Enable()
	EndIf
EndEvent

Event OnUpdate()
	If(playerRef.GetAnimationVariableFloat("Speed") != 0 || (playerRef.GetAnimationVariableBool("bInJumpState") && playerRef.GetAnimationVariableFloat("VelocityZ") > 0))
		playerRef.RemoveSpell(SneakToolsPlayerClimbingSpell)
		Game.EnablePlayerControls()
		climbingCollisionBox.Disable()
		playerRef.translateTo(playerRef.GetPositionX(), playerRef.GetPositionY(), playerRef.GetPositionZ(), playerRef.GetAngleX(), playerRef.GetAngleY(), playerRef.GetAngleZ(), 100)
		playerRef.RemovePerk(SneakToolsPlayerClimbingPerk)
		Game.SetGameSettingFloat("fJumpHeightMin", jumpHeight)
		return
	EndIf
	RegisterForSingleUpdate(0.1)
EndEvent

Event OnUpdateGameTime()
	If(!self.IsNearPlayer())
		cleanup()
		return
	Else
		RegisterForSingleUpdateGameTime(2)
	EndIf
EndEvent

Function cleanup()
	If(ropes != None)
		index = 0
		while(index < ropes.length)
			if(ropes[index] != None)
				ropes[index].Disable()
				ropes[index].Delete()
				index+=1
			else
				index=ropes.length
			endIf
		endWhile
	EndIf
	self.Disable()
	self.Delete()
EndFunction

