Scriptname xxxSurvivalismQuestScript extends Quest  

GlobalVariable Property xxxSURAnimalCount Auto
GlobalVariable Property xxxSURAnimalCountMax Auto

ReferenceAlias property aAnimal0 Auto
ReferenceAlias property aAnimal1 Auto
ReferenceAlias property aAnimal2 Auto

Faction Property xxxSURGatheredFaction Auto

Message Property AnimalDismissMessage Auto
message property mAlreadyAnimal Auto
Message Property mAlreadyGathered Auto

Race Property rDeer Auto
Race Property rWolf Auto
Race Property rSabrecat Auto
Race Property rSabrecatSnow Auto
Race Property rFox Auto
Race Property rBear Auto
Race Property rBearBlack Auto
Race Property rBearSnow Auto

MiscObject Property peltDeer Auto
MiscObject Property peltSabreCat Auto
MiscObject Property peltSabreCatSnow Auto
MiscObject Property peltFox Auto
MiscObject Property peltWolf Auto
MiscObject Property peltBear Auto
MiscObject Property peltBearBlack Auto
MiscObject Property peltBearSnow Auto

MiscObject Property peltDeerQuality Auto
MiscObject Property peltSabreCatQuality Auto
MiscObject Property peltSabreCatSnowQuality Auto
MiscObject Property peltFoxQuality Auto
MiscObject Property peltWolfQuality Auto
MiscObject Property peltBearQuality Auto
MiscObject Property peltBearBlackQuality Auto
MiscObject Property peltBearSnowQuality Auto

Int Property iChancePelt0 = 40 Auto
Int Property iChancePeltQuality0 = 20 Auto

Int Property iChancePelt1 = 80 Auto
Int Property iChancePeltQuality1 = 40 Auto

Perk Property pGatherer0 Auto
Perk Property pGatherer1 Auto

GlobalVariable property  gSurvivalismBaseExperience Auto

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Function SetAnimal(ObjectReference AnimalRef)

if xxxSURAnimalCount.getValue() == 0

	actor AnimalActor= AnimalRef as Actor
	AnimalActor.SetRelationshipRank(Game.GetPlayer(), 3)
	;game.getPlayer().stopCombat();
	;AnimalActor.stopCombat()
	AnimalActor.SetPlayerTeammate(abCanDoFavor = false)

	aAnimal0.ForceRefTo(AnimalActor)
aAnimal0.TryToEvaluatePackage()

	Debug.Notification(animalActor + " is now following you.");
	game.advanceskill("lockpicking", xxxSurvivalismBaseSkillGain.getValue() * 4)

	xxxSURAnimalCount.setValue(1)
else

	mAlreadyAnimal.show()
endif
	
EndFunction

Function AnimalWait()

	actor AnimalActor = aAnimal0.GetActorRef() as Actor
	AnimalActor.SetAv("WaitingForPlayer", 1)
	aAnimal0.RegisterForUpdateGameTime(72)

EndFunction

Function AnimalFollow()

	actor AnimalActor = aAnimal0.GetActorRef() as Actor
	AnimalActor.SetAv("WaitingForPlayer", 0)

EndFunction


Function DismissAnimal()

	If aAnimal0 && aAnimal0.GetActorRef().IsDead() == False
		actor DismissedAnimalActor = aAnimal0.GetActorRef() as Actor
		DismissedAnimalActor.SetActorValue("Variable04", 0)
		;DismissedAnimalActor.AllowPCDialogue(False)
		aAnimal0.Clear()
		AnimalDismissMessage.Show()
		xxxSURAnimalCount.setValue(0)
	EndIf

EndFunction

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Function Gather(objectreference animalref)

actor p = game.getPlayer()
actor a = animalref as actor

Race animalRace = a.getRace()

	if (animalRace)
		int randomRoll = Utility.randomInt()

		if (game.getPlayer().hasPerk(pGatherer1))
			if randomRoll < iChancePeltQuality1
					game.advanceskill("lockpicking", xxxSurvivalismBaseSkillGain.getValue() * 2)
				if animalRace == rWolf
					a.additem(peltWolfQuality, 1)
				elseif animalRace == rSabreCat
					a.additem(peltSabreCatQuality, 1)
				elseif animalRace == rSabreCatSnow
					a.additem(peltSabrecatSnowQuality, 1)
				elseif animalRace == rDeer
					a.additem(peltDeerQuality, 1)
				elseif animalRace == rFox
					a.additem(peltFoxQuality, 1)
				elseif animalRace == rBear
					a.additem(peltBearQuality, 1)
				elseif animalRace == rBearBlack
					a.additem(peltBearBlackQuality, 1)
				elseif animalRace == rBearSnow
					a.additem(peltBearSnowQuality, 1)
				endif
			elseif randomRoll < iChancePelt1
					game.advanceskill("lockpicking", xxxSurvivalismBaseSkillGain.getValue() * 1.5)
				if animalRace == rWolf
					a.additem(peltWolf, 1)
				elseif animalRace == rSabreCat
					a.additem(peltSabreCat, 1)
				elseif animalRace == rSabreCatSnow
					a.additem(peltSabrecatSnow, 1)
				elseif animalRace == rDeer
					a.additem(peltDeer, 1)
				elseif animalRace == rFox
					a.additem(peltFox, 1)
				elseif animalRace == rBear
					a.additem(peltBear, 1)
				elseif animalRace == rBearBlack
					a.additem(peltBearBlack, 1)
				elseif animalRace == rBearSnow
					a.additem(peltBearSnow, 1)
				endif
			endif
		else
			if randomRoll < iChancePeltQuality0
					game.advanceskill("lockpicking", xxxSurvivalismBaseSkillGain.getValue())
				if animalRace == rWolf
					a.additem(peltWolfQuality, 1)
				elseif animalRace == rSabreCat
					a.additem(peltSabreCatQuality, 1)
				elseif animalRace == rSabreCatSnow
					a.additem(peltSabrecatSnowQuality, 1)
				elseif animalRace == rDeer
					a.additem(peltDeerQuality, 1)
				elseif animalRace == rFox
					a.additem(peltFoxQuality, 1)
				elseif animalRace == rBear
					a.additem(peltBearQuality, 1)
				elseif animalRace == rBearBlack
					a.additem(peltBearBlackQuality, 1)
				elseif animalRace == rBearSnow
					a.additem(peltBearSnowQuality, 1)
				endif
			elseif randomRoll < iChancePelt0
					game.advanceskill("lockpicking", xxxSurvivalismBaseSkillGain.getValue() * 0.5)
				if animalRace == rWolf
					a.additem(peltWolf, 1)
				elseif animalRace == rSabreCat
					a.additem(peltSabreCat, 1)
				elseif animalRace == rSabreCatSnow
					a.additem(peltSabrecatSnow, 1)
				elseif animalRace == rDeer
					a.additem(peltDeer, 1)
				elseif animalRace == rFox
					a.additem(peltFox, 1)
				elseif animalRace == rBear
					a.additem(peltBear, 1)
				elseif animalRace == rBearBlack
					a.additem(peltBearBlack, 1)
				elseif animalRace == rBearSnow
					a.additem(peltBearSnow, 1)
				endif
			endif
		endif
	a.addToFaction(xxxSURGatheredFaction)
	endif
	
EndFunction

Function awareness(ObjectReference trap)

		trap.disable()
		trap.delete()

	; disarm regular bear traps
	if trap.hasKeyword(xxxWAYTrapBearKeyword)
		game.getPlayer().addItem(xxxWayHuntingGroundsTrapBear, 1)
		game.advanceskill("lockpicking", 3)
	elseif trap.hasKeyword(xxxWAYTrapPlacedKeyword)
		; handle normal traps, placed
		game.getPlayer().addItem(xxxWayHuntingGroundsTrapBear, 1)
	elseif trap.hasKeyword(xxxWAYTrapPoisonKeyword)
		; poisoned traps lose poison
		game.getPlayer().addItem(xxxWayHuntingGroundsTrapBear, 1)
	elseif trap.haskeyword(xxxWAYTrapBearExplosiveKeyword)
		game.getPlayer().addItem(xxxWayHuntingGroundsTrapBearExplosive, 1)
	elseif trap.haskeyword(xxxWAYTrapBearFireKeyword)
		game.getPlayer().addItem(xxxWayHuntingGroundsTrapBearFire, 1)
	elseif trap.haskeyword(xxxWAYTrapBearFrostKeyword)
		game.getPlayer().addItem(xxxWayHuntingGroundsTrapBearFrost, 1)
	elseif trap.haskeyword(xxxWAYTrapBearShockKeyword)
		game.getPlayer().addItem(xxxWayHuntingGroundsTrapBearShock, 1)
	endif
EndFunction

Keyword Property xxxWAYTrapBearKeyword Auto
Keyword Property xxxWAYTrapPlacedKeyword Auto
Keyword Property xxxWAYTrapPoisonKeyword Auto
Keyword Property xxxWAYTrapBearExplosiveKeyword Auto
Keyword Property xxxWAYTrapBearShockKeyword Auto
Keyword Property xxxWAYTrapBearFrostKeyword Auto
Keyword Property xxxWAYTrapBearFireKeyword Auto

MiscObject Property xxxWayHuntingGroundsTrapBear Auto
MiscObject Property xxxWayHuntingGroundsTrapBearExplosive Auto
MiscObject Property xxxWayHuntingGroundsTrapBearFire Auto
MiscObject Property xxxWayHuntingGroundsTrapBearFrost Auto
MiscObject Property xxxWayHuntingGroundsTrapBearShock Auto

GlobalVariable Property xxxSurvivalismBaseSkillGain  Auto  
