Scriptname xxxVampireQuest extends Quest  Conditional

Event OnUpdateGameTime()

	;just in case
	if (game.getPlayer().hasperk(AmongVermin) && !(game.getPlayer().isInFaction(AdvancedVampireFaction)))
		game.getPlayer().addToFaction(AdvancedVampireFaction)
	endif
	
	game.advanceSkill("lockpicking",iSkillGain*2)
	
	;Feed timer
	FeedTimer = GameDaysPassed.Value - LastFeedTime
	
	;Apply debuffs based on time you did not feed (VS == x -> VS += 1 (stage vs+1 reached))
		If (FeedTimer >= 9) && (VampireStatus == 9)
			VampireFeedReady.SetValue(9)
			VampireStageProgressionMessage.Show()
			VampireStatus = 10
			VampireProgression(Game.GetPlayer(), 10)

		ElseIf FeedTimer >= 8 && (VampireStatus == 8)
			VampireFeedReady.SetValue(8)
			VampireStageProgressionMessage.Show()
			VampireStatus = 9
			VampireProgression(Game.GetPlayer(), 9)

		ElseIf FeedTimer >= 7 && (VampireStatus == 7)
			VampireFeedReady.SetValue(7)
			VampireStageProgressionMessage.Show()
			VampireStatus = 8
			VampireProgression(Game.GetPlayer(), 8)

		ElseIf FeedTimer >= 6 && (VampireStatus == 6)
			VampireFeedReady.SetValue(6)
			VampireStageProgressionMessage.Show()
			VampireStatus = 7
			VampireProgression(Game.GetPlayer(), 7)

		ElseIf FeedTimer >= 5 && (VampireStatus == 5)
			VampireFeedReady.SetValue(5)
			VampireStageProgressionMessage.Show()
			VampireStatus = 6
			VampireProgression(Game.GetPlayer(), 6)

		ElseIf FeedTimer >= 4 && (VampireStatus == 4)
			VampireFeedReady.SetValue(4)
			VampireStageProgressionMessage.Show()
			VampireStatus = 5
			VampireProgression(Game.GetPlayer(), 5)

		ElseIf FeedTimer >= 3 && (VampireStatus == 3)
			VampireFeedReady.SetValue(3)
			VampireStageProgressionMessage.Show()
			VampireStatus = 4
			VampireProgression(Game.GetPlayer(), 4)

		ElseIf FeedTimer >= 2 && (VampireStatus == 2)
			VampireFeedReady.SetValue(2)
			VampireStageProgressionMessage.Show()
			VampireStatus = 3
			VampireProgression(Game.GetPlayer(), 3)	

		ElseIf FeedTimer >= 1 && (VampireStatus == 1)
			VampireFeedReady.SetValue(1)
			VampireStageProgressionMessage.Show()
			VampireStatus = 2
			VampireProgression(Game.GetPlayer(), 2)	

		EndIf
	
EndEvent


Function VampireFeedBed()

	Game.GetPlayer().PlayIdle(VampireFeedingBedRight)

EndFunction


Function VampireFeedBedRoll()

	Game.GetPlayer().PlayIdle(VampireFeedingBedrollRight)

EndFunction


Function VampireChange(Actor Target)
	;Effects for hiding the change
	Game.DisablePlayerControls()
	VampireChangeFX.play(Target)
	VampireTransformIncreaseISMD.applyCrossFade(2.0)
	ObjectReference myXmarker = Target.PlaceAtMe(Xmarker)
	MAGVampireTransform01.Play(myXmarker)
	myXmarker.Disable()
	utility.wait(2.0)
	imageSpaceModifier.removeCrossFade()
	VampireChangeFX.stop(Target)

	;Change player's race, defaults to Nord Vampire
	if (Target.GetActorBase().GetRace() == ArgonianRace)
		CureRace = ArgonianRace
		Target.SetRace(ArgonianRaceVampire)
	elseif (Target.GetActorBase().GetRace() == BretonRace)
		CureRace = BretonRace
		Target.SetRace(BretonRaceVampire) 
	elseif (Target.GetActorBase().GetRace() == DarkElfRace)
		CureRace = DarkElfRace
		Target.SetRace(DarkElfRaceVampire) 
	elseif (Target.GetActorBase().GetRace() == HighELfRace)
		CureRace = HighELfRace
		Target.SetRace(HighELfRaceVampire) 
	elseif (Target.GetActorBase().GetRace() == ImperialRace)
		CureRace = ImperialRace
		Target.SetRace(ImperialRaceVampire) 
	elseif (Target.GetActorBase().GetRace() == KhajiitRace)
		CureRace = KhajiitRace
		Target.SetRace(KhajiitRaceVampire) 
	elseif (Target.GetActorBase().GetRace() == NordRace)
		CureRace = NordRace
		Target.SetRace(NordRaceVampire) 
	elseif (Target.GetActorBase().GetRace() == OrcRace)
		CureRace = OrcRace
		Target.SetRace(OrcRaceVampire) 
	elseif (Target.GetActorBase().GetRace() == RedguardRace)
		CureRace = RedguardRace
		Target.SetRace(RedguardRaceVampire) 
	elseif (Target.GetActorBase().GetRace() == WoodElfRace)
		CureRace = WoodElfRace
		Target.SetRace(WoodElfRaceVampire) 
	endif

	;Clear player's diseases
	;VampireCureDisease.Cast(Target)
	Target.RemoveSpell(DiseaseBoneBreakFever)
	Target.RemoveSpell(DiseaseBrainRot )
	Target.RemoveSpell(DiseaseRattles )
	Target.RemoveSpell(DiseaseRockjoint )
	Target.RemoveSpell(DiseaseWitbane )
	Target.RemoveSpell(DiseasePorphyricHemophelia)

	;add Restoration penalty

	if !(game.getPlayer().hasSpell(sVampireRestoration))
		game.getPlayer().addspell(sVampireRestoration)
	endif

	if !(game.getPlayer().hasSpell(VampireSunDamage))
		game.getPlayer().addSpell(VampireSunDamage)
	endif

	if !(game.getPlayer().hasSpell(sVampiricSight))
		game.getPlayer().addSpell(sVampiricSight)
	endif

	;Make player Vampire Stage 1
	VampireStatus = 1
	Game.GetPlayer().AddtoFaction(VampirePCFaction)
	if (game.getPlayer().hasperk(AmongVermin) && !(game.getPlayer().isInFaction(AdvancedVampireFaction)))
		game.getPlayer().addToFaction(AdvancedVampireFaction)
	endif
	VampireProgression(Game.GetPlayer(), 1)
	
	;Setup the Feed Timers
	RegisterForUpdateGameTime(12)
	LastFeedTime =  GameDaysPassed.Value

	;Set the Global for stat tracking
	PlayerIsVampire.SetValue(1)
	
	Utility.Wait(1)
	Game.EnablePlayerControls()	

	;If the player has been cured before, restart the cure quest
	If VC01.GetStageDone(200) == 1
		VC01.SetStage(25)
	EndIf
	
EndFunction


Function VampireFeed()
	;Effects for hiding the change
	;VampireChangeFX.play(game.getPlayer())
	VampireTransformDecreaseISMD.applyCrossFade(2.0)
	utility.wait(2.0)
	imageSpaceModifier.removeCrossFade()
	;VampireChangeFX.stop(game.getPlayer())
	
	Game.IncrementStat( "Necks Bitten" )
	VampireFeedMessage.Show()
	VampireFeedReady.SetValue(0)
	LastFeedTime =  GameDaysPassed.Value

	if (VampireStatus > 8)
		game.advanceSkill("lockpicking", iSkillGain*5)
	elseif (VampireStatus > 6)
		game.advanceSkill("lockpicking", iSkillGain*4)
	elseif (VampireStatus > 4)
		game.advanceSkill("lockpicking", iSkillGain*3)
	elseif (VampireStatus > 2)
		game.advanceSkill("lockpicking", iSkillGain*2)
	elseif (VampireStatus > 1)
		game.advanceSkill("lockpicking", iSkillGain)
	endif

	VampireStatus = 1
	VampireProgression(Game.GetPlayer(), 1)


	;Start checking GameTime again if we weren't already
	UnregisterforUpdateGameTime()
	RegisterForUpdateGameTime(12)

	;update all variables that need it
	if (game.getPlayer().hasperk(pVolkiharLore2) && gFBPMax.getValue() != 3)
		gFBPMax.setValue(3)
	elseif (game.getPlayer().hasperk(pVolkiharLore1) && gFBPMax.getValue() != 2)
		gFBPMax.setValue(2)
	elseif (game.getPlayer().hasperk(pVolkiharLore0) && gFBPMax.getValue() != 1)
		gFBPMax.setValue(1)
	endif

	if (!(game.getPlayer().hasSpell(sWorldOfIce)) && game.getPlayer().hasPerk(pWorldOfIce))
		game.getPlayer().addSpell(sWorldOfIce)
	endif

	if (!(game.getPlayer().hasSpell(sFrostBloodPrison)) && game.getPlayer().hasPerk(pVolkiharLore0))
		game.getPlayer().addSpell(sFrostBloodPrison)
	endif

	if (game.getPlayer().hasperk(pWorldOfIce) && gWOIMax.getValue() != 1)
		gWOIMax.setValue(1)
	endif
	
	if  !(game.getPlayer().hasSpell(sInnerCircleTrigger))&& (game.getPlayer().hasPerk(pInnerCircle))
		game.getPlayer().addSpell(sInnerCircleTrigger)
	endif

	if (game.getPlayer().hasperk(pDomination))
		game.getPlayer().addSpell(sDominate)
	endif

	;just in case
	if (game.getPlayer().hasperk(AmongVermin) && !(game.getPlayer().isInFaction(AdvancedVampireFaction)))
		game.getPlayer().addToFaction(AdvancedVampireFaction)
	endif

	;reset counts for world of ice and frost blood prison

	gFBPCount.setValue(0)
	gWOICount.setValue(0)

EndFunction


Function VampireProgression(Actor Player, int VampireStage)
	;Swap out abilities depending on time you didn't feed
	
	If VampireStage == 2
		VampireTransformIncreaseISMD.applyCrossFade(2.0)
			game.getPlayer().addspell(sPassive1)
			game.getPlayer().removespell(sPassive0)
		if (game.getPlayer().hasSpell(sSinisterStrength))
			game.getPlayer().removeSpell(sSinisterStrength)
		endif
		if (game.getPlayer().hasSpell(sPromiseOfPower))
			game.getPlayer().removeSpell(sPromiseOfPower)
		endif
		utility.wait(2.0)
		imageSpaceModifier.removeCrossFade()		

	ElseIf VampireStage == 3
		VampireTransformIncreaseISMD.applyCrossFade(2.0)
			game.getPlayer().addspell(sPassive2)
			game.getPlayer().removespell(sPassive1)
		utility.wait(2.0)
		imageSpaceModifier.removeCrossFade()

	ElseIf VampireStage == 4
		VampireTransformIncreaseISMD.applyCrossFade(2.0)
			game.getPlayer().addspell(sPassive3)
			game.getPlayer().removespell(sPassive2)
		utility.wait(2.0)
		imageSpaceModifier.removeCrossFade()
		
	ElseIf VampireStage == 5
		VampireTransformIncreaseISMD.applyCrossFade(2.0)
			game.getPlayer().addspell(sPassive4)
			game.getPlayer().removespell(sPassive3)
		utility.wait(2.0)
		imageSpaceModifier.removeCrossFade()

	ElseIf VampireStage == 6
		VampireTransformIncreaseISMD.applyCrossFade(2.0)
			game.getPlayer().addspell(sPassive5)
			game.getPlayer().removespell(sPassive4)
		utility.wait(2.0)
		imageSpaceModifier.removeCrossFade()

	ElseIf VampireStage == 7
		VampireTransformIncreaseISMD.applyCrossFade(2.0)
			game.getPlayer().addspell(sPassive6)
			game.getPlayer().removespell(sPassive5)
		utility.wait(2.0)
		imageSpaceModifier.removeCrossFade()

	ElseIf VampireStage == 8
		VampireTransformIncreaseISMD.applyCrossFade(2.0)
			game.getPlayer().addspell(sPassive7)
			game.getPlayer().removespell(sPassive6)
		utility.wait(2.0)
		imageSpaceModifier.removeCrossFade()

	ElseIf VampireStage == 9
		VampireTransformIncreaseISMD.applyCrossFade(2.0)
			game.getPlayer().addspell(sPassive8)
			game.getPlayer().removespell(sPassive7)
		utility.wait(2.0)
		imageSpaceModifier.removeCrossFade()

	ElseIf VampireStage == 10
		VampireTransformIncreaseISMD.applyCrossFade(2.0)
			game.getPlayer().addspell(sPassive9)
			game.getPlayer().removespell(sPassive8)
		utility.wait(2.0)
		imageSpaceModifier.removeCrossFade()

	ElseIf VampireStage == 1
		if (game.getPlayer().hasSpell(sPassive1))
			game.getPlayer().removespell(sPassive1)
		elseif (game.getPlayer().hasSpell(sPassive2))
			game.getPlayer().removespell(sPassive2)
		elseif (game.getPlayer().hasSpell(sPassive3))
			game.getPlayer().removespell(sPassive3)
		elseif (game.getPlayer().hasSpell(sPassive4))
			game.getPlayer().removespell(sPassive4)
		elseif (game.getPlayer().hasSpell(sPassive5))
			game.getPlayer().removespell(sPassive5)
		elseif (game.getPlayer().hasSpell(sPassive6))
			game.getPlayer().removespell(sPassive6)
		elseif (game.getPlayer().hasSpell(sPassive7))
			game.getPlayer().removespell(sPassive7)
		elseif (game.getPlayer().hasSpell(sPassive8))
			game.getPlayer().removespell(sPassive8)
		elseif (game.getPlayer().hasSpell(sPassive9))
			game.getPlayer().removespell(sPassive9)
		endif

		game.getPlayer().addspell(sPassive0)	

		if (game.getPlayer().hasPerk(pSinisterStrength))
			game.getPlayer().addSpell(sSinisterStrength)
		endif
		if (game.getPlayer().hasPerk(pPromiseOfPower))
			game.getPlayer().addSpell(sPromiseOfPower)
		endif
	EndIf
EndFunction

Function VampireCure(Actor Player)
	
	Game.IncrementStat( "Vampirism Cures" )
	;Stop tracking the Feed Timer
	UnregisterforUpdateGameTime()

	VampireStatus = 0
	
	;Remove all abilities and factions

	if ( game.getPlayer().isInFaction(AdvancedVampireFaction))
		game.getPlayer().removeFromFaction(AdvancedVampireFaction)
	endif
	game.getPlayer().removeFromFaction(VampirePCFaction)

	if (game.getPlayer().hasSpell(sFrostBloodPrison))
		game.getPlayer().removeSpell(sFrostBloodPrison)
	endif

	if (game.getPlayer().hasSpell(sWorldOfIce))
		game.getPlayer().removeSpell(sWorldOfIce)
	endif

	if (game.getPlayer().hasSpell(sDominate))
		game.getPlayer().removeSpell(sDominate)
	endif

	if (game.getPlayer().hasSpell(sInnerCircleBase))
		game.getPlayer().removeSpell(sInnerCircleBase)
	endif

	if (game.getPlayer().hasSpell(sInnerCircleTrigger))
		game.getPlayer().removeSpell(sInnerCircleTrigger)
	endif

	if (game.getPlayer().hasSpell(sVampireRestoration))
		game.getPlayer().removespell(sVampireRestoration)
	endif

	if (game.getPlayer().hasSpell(VampireSunDamage))
		game.getPlayer().removeSpell(VampireSunDamage)
	endif


	if (game.getPlayer().hasSpell(sPassive0))
		game.getPlayer().removespell(sPassive0)
	elseif (game.getPlayer().hasSpell(sPassive1))
		game.getPlayer().removespell(sPassive1)
	elseif (game.getPlayer().hasSpell(sPassive2))
		game.getPlayer().removespell(sPassive2)
	elseif (game.getPlayer().hasSpell(sPassive3))
		game.getPlayer().removespell(sPassive3)
	elseif (game.getPlayer().hasSpell(sPassive4))
		game.getPlayer().removespell(sPassive4)
	elseif (game.getPlayer().hasSpell(sPassive5))
		game.getPlayer().removespell(sPassive5)
	elseif (game.getPlayer().hasSpell(sPassive6))
		game.getPlayer().removespell(sPassive6)
	elseif (game.getPlayer().hasSpell(sPassive7))
		game.getPlayer().removespell(sPassive7)
	elseif (game.getPlayer().hasSpell(sPassive8))
		game.getPlayer().removespell(sPassive8)
	elseif (game.getPlayer().hasSpell(sPassive9))
		game.getPlayer().removespell(sPassive9)
	endif
	
	
	;Change player's race
	if (Player.GetRace() == ArgonianRaceVampire)
		Player.SetRace(ArgonianRace)
	elseif (Player.GetRace() == BretonRaceVampire)
		Player.SetRace(BretonRace) 
	elseif (Player.GetRace() == DarkElfRaceVampire)
		Player.SetRace(DarkElfRace) 
	elseif (Player.GetRace() == HighELfRaceVampire)
		Player.SetRace(HighElfRace) 
	elseif (Player.GetRace() == ImperialRaceVampire)
		Player.SetRace(ImperialRace) 
	elseif (Player.GetRace() == KhajiitRaceVampire)
		Player.SetRace(KhajiitRace) 
	elseif (Player.GetRace() == NordRaceVampire)
		Player.SetRace(NordRace) 
	elseif (Player.GetRace() == OrcRaceVampire)
		Player.SetRace(OrcRace) 
	elseif (Player.GetRace() == RedguardRaceVampire)
		Player.SetRace(RedguardRace) 
	elseif (Player.GetRace() == WoodElfRaceVampire)
		Player.SetRace(WoodElfRace) 
	endif

	if (game.getPlayer().hasSpell(sVampiricSight))
		game.getPlayer().removeSpell(sVampiricSight)
	endif

	;Set the Global for stat tracking
	PlayerIsVampire.SetValue(0)
	
EndFunction


Spell Property VampireSunDamage Auto

Spell Property sPassive0 Auto
Spell Property sPassive1 Auto
Spell Property sPassive2 Auto
Spell Property sPassive3 Auto
Spell Property sPassive4 Auto
Spell Property sPassive5 Auto
Spell Property sPassive6 Auto
Spell Property sPassive7 Auto
Spell Property sPassive8 Auto
Spell Property sPassive9 Auto

Spell Property sVampiricSight Auto

Spell Property VampireCureDisease Auto

Spell Property DiseasePorphyricHemophelia Auto
Spell Property DiseaseAtaxia auto
Spell Property DiseaseBoneBreakFever Auto
Spell Property DiseaseBrainRot Auto
Spell Property DiseaseRattles Auto
Spell Property DiseaseRockjoint auto
Spell Property DiseaseWitbane Auto 

Spell Property sWorldOfIce Auto
Spell Property sFrostBloodPrison Auto 
Spell Property sPromiseOfPower Auto
Spell Property sSinisterStrength Auto

Spell Property sDominate Auto

Spell Property sInnerCircleTrigger Auto
Spell Property sInnerCircleBase Auto

Spell Property sVampireRestoration Auto

Sound  Property MagVampireTransform01  Auto  

Quest Property VC01 Auto
  
Int Property iSkillGain Auto
Int Property VampireStatus Auto Conditional

Message Property VampireFeedMessage Auto
Message Property VampireStageProgressionMessage Auto

Race Property ArgonianRace  Auto  
Race Property ArgonianRaceVampire  Auto  
Race Property BretonRace  Auto  
Race Property BretonRaceVampire  Auto  
Race Property DarkElfRace  Auto  
Race Property DarkElfRaceVampire  Auto  
Race Property HighElfRace  Auto  
Race Property HighElfRaceVampire  Auto  
Race Property ImperialRace  Auto  
Race Property ImperialRaceVampire  Auto  
Race Property KhajiitRace  Auto  
Race Property KhajiitRaceVampire  Auto  
Race Property NordRace  Auto  
Race Property NordRaceVampire  Auto  
Race Property OrcRace  Auto  
Race Property OrcRaceVampire  Auto  
Race Property RedguardRace  Auto  
Race Property RedguardRaceVampire  Auto  
Race Property WoodElfRace  Auto  
Race Property WoodElfRaceVampire  Auto  
Race Property CureRace Auto

Static Property XMarker Auto

Faction Property VampirePCFaction  Auto
Faction Property AdvancedVampireFaction  Auto

Perk Property AmongVermin Auto
Perk Property pVolkiharLore0 Auto
Perk Property pVolkiharLore1 Auto
Perk Property pVolkiharLore2 Auto
Perk Property pDomination Auto
Perk Property pWorldOfIce Auto
Perk Property pSinisterStrength Auto
Perk Property pPromiseOfPower Auto
Perk Property pInnerCircle Auto

Float Property LastFeedTime Auto
Float Property FeedTimer Auto

GlobalVariable Property PlayerIsVampire  Auto
GlobalVariable Property GameDaysPassed Auto
GlobalVariable Property VampireFeedReady Auto
GlobalVariable Property gFBPMax Auto
GlobalVariable Property gFBPCount Auto
GlobalVariable Property gWOIMax Auto
GlobalVariable Property gWOICount Auto

Idle Property VampireFeedingBedRight Auto
Idle Property VampireFeedingBedrollRight Auto

imageSpaceModifier Property VampireTransformIncreaseISMD  Auto
imageSpaceModifier Property VampireTransformDecreaseISMD  Auto 
effectShader property VampireChangeFX auto
