Scriptname xxxWAYTrapScript extends ObjectReference  


xxxWAYTrapHitScript hitBase
bool property StartOpen = True Auto
bool property destroyOnTrigger = False Auto
perk property LightFoot auto
bool property checkForLightFootPerk = true Auto
{default == true}
globalVariable property LightFootTriggerPercent auto
int property intBreakChance = 30 Auto

Event onReset()
	goToState("Closed")
	self.reset()
endEvent


event onLoad()
	hitBase = (self as objectReference) as xxxWAYTrapHitScript
	if StartOpen
		playAnimation("StartOpen")
		goToState("Open")
	endif
endEvent

auto state Closed
	
	event OnActivate(objectReference TriggerRef)
		playAnimationAndWait("Reset01","Trans02")
		goToState("Open")
	endEvent
	
endState

state Open
	event OnTriggerEnter(objectReference TriggerRef)
		if !(triggerref as actor)
			GoToState("Closed")
		endif

		if checkPerks(TriggerRef)
			calculateDamage(TriggerRef)
			playAnimation("Trigger01")
			hitBase.goToState("CanHit")
			GoToState("Busy")
			WaitForAnimationEvent("Trans01")
			hitBase.goToState("CannotHit")
			if destroyOnTrigger
				self.disable()
				self.delete()
			elseif utility.randomInt() < intBreakChance
				Debug.notification("A trap placed by you has broken.")
				self.disable()
				self.deletewhenable()
			else
				GoToState("Closed")
			endif
		endif
	endEvent
	
	event OnActivate(objectReference TriggerRef)
		GoToState("Busy")
		hitBase.goToState("CannotHit")
		playAnimationAndWait("Trigger01","Trans01")
		goToState("Closed")
	endEvent

endState

State Busy
EndState

Bool function checkPerks(objectReference triggerRef)
	if checkForLightFootPerk
		if  (triggerRef as actor).hasPerk(LightFoot)
			if utility.randomFloat(0.0,100.00) <= LightFootTriggerPercent.getValue()
				return False
			else
				return True
			endif
		Else
			Return True
		EndIf
	else
		return True
	endif
endFunction


int property damageBase Auto
int property damage0 Auto
int property damage1 Auto 
int property damage2 Auto
int property damage3 Auto
int property damage4 Auto

perk property xxxWAYSilentHunt0 Auto
perk property xxxWAYSilentHunt1 Auto
perk property xxxWAYSilentHunt2 Auto
perk property xxxWAYSilentHunt3 Auto
perk property xxxWAYSilentHunt4 Auto

perk property xxxWAYLegcutter Auto

Function calculateDamage(ObjectReference TriggerRef)
	
int calculatedDamage = damageBase

actor player = game.getPlayer()

	if (player.hasperk(xxxWAYSilentHunt4))
		calculatedDamage = damage4
	elseif (player.hasperk(xxxWAYSilentHunt3))
		calculatedDamage = damage3
	elseif (player.hasperk(xxxWAYSilentHunt2))
		calculatedDamage = damage2
	elseif (player.hasperk(xxxWAYSilentHunt1))
		calculatedDamage = damage1
	elseif (player.hasperk(xxxWAYSilentHunt0))
		calculatedDamage = damage0
	endif

;Debug.notification("Dealing "+calculatedDamage+" originally")

if !(player.hasperk(xxxWAYLegcutter)) && TriggerRef as actor
	int damageResistance = (TriggerRef as actor).getAV("DamageResist") as int
;	Debug.notification("DR: "+damageResistance)
	calculatedDamage = calculatedDamage*(800-damageResistance)/800
endif

hitBase.damage=calculatedDamage
	
if ((triggerref as actor) != player)
	game.advanceskill("lockpicking", 3)
endif

;Debug.notification("Dealing "+calculatedDamage+" damage")
EndFunction

