Scriptname xxxWAYTrapSpikes extends ObjectReference  


int property damage auto hidden
int property soundLevel = 10 auto 
int property trapPushBack auto
sound property TrapHitSound auto
weapon property hitFX auto
ammo property hitFXAmmo auto
int property trapLevel = 1 auto
bool isWaitingToEvaluate = False
float property staggerAmount = 0.0 auto
bool property CheckAngle = false auto
{if true this will check the angle of the actors velocity to the "up" vector of the trap
	default == False}

Spell Property trapSpell = none Auto

auto State CanHit
	
	Event OnTrapHit(ObjectReference akTarget, float afXVel, float afYVel, float afZVel, float afXPos, float afYPos, float afZPos, int aeMaterial, bool abInitialHit, int aeMotionType)
		if !CheckAngle
			doLocalHit(akTarget, afXVel, afYVel, afZVel, afXPos, afYPos, afZPos, aeMaterial, abInitialHit, aeMotionType)
		else
			if isAngleAcceptable(afXVel, afYVel, afZVel)
				doLocalHit(akTarget, afXVel, afYVel, afZVel, afXPos, afYPos, afZPos, aeMaterial, abInitialHit, aeMotionType)
			endif
		endif
	endEvent
	
	
	Event OnTrapHitStart(ObjectReference akTarget, float afXVel, float afYVel, float afZVel, float afXPos, float afYPos, float afZPos, int aeMaterial, bool abInitialHit, int aeMotionType)
		if !CheckAngle
			doLocalHit(akTarget, afXVel, afYVel, afZVel, afXPos, afYPos, afZPos, aeMaterial, abInitialHit, aeMotionType)
		else
			if isAngleAcceptable(afXVel, afYVel, afZVel)
				doLocalHit(akTarget, afXVel, afYVel, afZVel, afXPos, afYPos, afZPos, aeMaterial, abInitialHit, aeMotionType)
			endif
		endif
	endEvent
EndState

State CannotHit
endState


event onUpdate()
	unRegisterForUpdate()
	;EvaluateStoredRefs()
	isWaitingToEvaluate = FALSE
endEvent

function doLocalHit(ObjectReference akTarget, float afXVel, float afYVel, float afZVel, float afXPos, float afYPos, float afZPos, int aeMaterial, bool abInitialHit, int aeMotionType)
	calculateDamage(akTarget)
	if trapSpell
		trapSpell.cast(akTarget, akTarget)
	endif
	akTarget.ProcessTrapHit(self, damage, trapPushBack, afXVel, afYVel, afZVel, afXPos, afYPos, afZPos, aeMaterial, staggerAmount)
	TrapHitSound.play( self as ObjectReference)		;play hit sound
	hitFX.fire(self, hitFxAmmo)
	CreateDetectionEvent(akTarget as actor, soundLevel) ; creates a detection event
endFunction



bool function isAngleAcceptable(float afXVel, float afYVel, float afZVel)
	float maxZVelocity = 1.0
	float minZVelocity = 0.3
	
	float absoluteZ = (math.abs(afZVel))
	float absoluteY = math.abs(afYVel)
	float absoluteX = math.abs(afXVel)

	if  absoluteZ  >= maxZVelocity
		return true
	elseif absoluteZ  >= minZVelocity
		if (absoluteZ * (0.6)) >= absoluteY 
			return True
		elseif (absoluteZ * (0.6)) >= absoluteX
			Return True
		else
			return False
		endif
	else
		return false
	endif
endFunction

	
int property damageBase Auto
int property damage0 Auto
int property damage1 Auto
int property damage2 Auto
int property damage3 Auto
int property damage4 Auto

perk property xxxWAYSilentHunt0 Auto
perk property xxxWAYSilentHunt1 Auto
perk property xxxWAYSilentHunt2 Auto
perk property xxxWAYSilentHunt3 Auto
perk property xxxWAYSilentHunt4 Auto

perk property xxxWAYLegcutter Auto

Function calculateDamage(objectreference aktargetref)

	if aktargetref as actor
		actor p = game.getPlayer()
		damage = damageBase
	
		if p.hasperk(xxxWAYSilentHunt4)
			damage = damage4
		elseif p.hasperk(xxxWAYSilentHunt3)
			damage = damage3
		elseif p.hasperk(xxxWAYSilentHunt2)
			damage = damage2
		elseif p.hasperk(xxxWAYSilentHunt1)
			damage = damage1
		elseif p.hasperk(xxxWAYSilentHunt4)
			damage = damage0
		endif
		
		if !(p.hasPerk(xxxWAYLegcutter))
			int damageResist = (aktargetref as actor).getAV("damageResist") as int
			damage = damage * (800 - damageResist)/800
		endif
		;(aktargetref as actor).damageAV("health", damage)
	endif
EndFunction

